diff --git a/meta-oe/recipes-extended/acpica/acpica_20130823.bb b/meta-oe/recipes-extended/acpica/acpica_20130823.bb
deleted file mode 100644
index 15dbeba..0000000
--- a/meta-oe/recipes-extended/acpica/acpica_20130823.bb
+++ /dev/null
@@ -1,37 +0,0 @@
-SUMMARY = "ACPICA tools for the development and debug of ACPI tables"
-DESCRIPTION = "The ACPI Component Architecture (ACPICA) project provides an \
-OS-independent reference implementation of the Advanced Configuration and \
-Power Interface Specification (ACPI). ACPICA code contains those portions of \
-ACPI meant to be directly integrated into the host OS as a kernel-resident \
-subsystem, and a small set of tools to assist in developing and debugging \
-ACPI tables."
-HOMEPAGE = "http://www.acpica.org/"
-SECTION = "console/tools"
-LICENSE = "BSD | GPLv2"
-LIC_FILES_CHKSUM = "file://generate/unix/readme.txt;md5=204407e197c1a01154a48f6c6280c3aa"
-DEPENDS = "bison flex"
-PR="r1"
-
-SRC_URI = "https://acpica.org/sites/acpica/files/acpica-unix2-${PV}.tar.gz \
-    file://cross-compile.patch \
-    file://no-werror.patch \
-    file://fix-parallel-build.patch"
-
-SRC_URI[md5sum] = "6694a6a5baa4a23fba892b8ad23f3959"
-SRC_URI[sha256sum] = "dcaf8bcdd146006e7c480d4249e014e38eb2ae3e4d2d40f90ec454312cc7e4d1"
-
-S = "${WORKDIR}/acpica-unix2-${PV}"
-
-EXTRA_OEMAKE = "'OPT_CFLAGS=-Wall'"
-
-do_install() {
-    install -D -p -m0755 generate/unix/bin*/iasl ${D}${bindir}/iasl
-    install -D -p -m0755 generate/unix/bin*/acpibin ${D}${bindir}/acpibin
-    install -D -p -m0755 generate/unix/bin*/acpiexec ${D}${bindir}/acpiexec
-    install -D -p -m0755 generate/unix/bin*/acpihelp ${D}${bindir}/acpihelp
-    install -D -p -m0755 generate/unix/bin*/acpinames ${D}${bindir}/acpinames
-    install -D -p -m0755 generate/unix/bin*/acpisrc ${D}${bindir}/acpisrc
-    install -D -p -m0755 generate/unix/bin*/acpixtract ${D}${bindir}/acpixtract
-}
-
-COMPATIBLE_HOST = "(i.86|x86_64|arm|aarch64).*-linux"
diff --git a/meta-oe/recipes-extended/acpica/acpica_20131115.bb b/meta-oe/recipes-extended/acpica/acpica_20131115.bb
new file mode 100644
index 0000000..8c9ecd4
--- /dev/null
+++ b/meta-oe/recipes-extended/acpica/acpica_20131115.bb
@@ -0,0 +1,36 @@
+SUMMARY = "ACPICA tools for the development and debug of ACPI tables"
+DESCRIPTION = "The ACPI Component Architecture (ACPICA) project provides an \
+OS-independent reference implementation of the Advanced Configuration and \
+Power Interface Specification (ACPI). ACPICA code contains those portions of \
+ACPI meant to be directly integrated into the host OS as a kernel-resident \
+subsystem, and a small set of tools to assist in developing and debugging \
+ACPI tables."
+HOMEPAGE = "http://www.acpica.org/"
+SECTION = "console/tools"
+LICENSE = "BSD | GPLv2"
+LIC_FILES_CHKSUM = "file://generate/unix/readme.txt;md5=204407e197c1a01154a48f6c6280c3aa"
+DEPENDS = "bison flex"
+
+SRC_URI = "https://acpica.org/sites/acpica/files/acpica-unix2-${PV}.tar.gz \
+    file://cross-compile.patch \
+    file://no-werror.patch \
+    "
+
+SRC_URI[md5sum] = "1bd5b14c4c567ca2a113c05f4b28f29c"
+SRC_URI[sha256sum] = "d699a880b84e04205eda2d5ad048c1c38a57289240caa5f0fb7ebdcd3aac83d2"
+
+S = "${WORKDIR}/acpica-unix2-${PV}"
+
+EXTRA_OEMAKE = "'OPT_CFLAGS=-Wall'"
+
+do_install() {
+    install -D -p -m0755 generate/unix/bin*/iasl ${D}${bindir}/iasl
+    install -D -p -m0755 generate/unix/bin*/acpibin ${D}${bindir}/acpibin
+    install -D -p -m0755 generate/unix/bin*/acpiexec ${D}${bindir}/acpiexec
+    install -D -p -m0755 generate/unix/bin*/acpihelp ${D}${bindir}/acpihelp
+    install -D -p -m0755 generate/unix/bin*/acpinames ${D}${bindir}/acpinames
+    install -D -p -m0755 generate/unix/bin*/acpisrc ${D}${bindir}/acpisrc
+    install -D -p -m0755 generate/unix/bin*/acpixtract ${D}${bindir}/acpixtract
+}
+
+COMPATIBLE_HOST = "(i.86|x86_64|arm|aarch64).*-linux"
diff --git a/meta-oe/recipes-extended/acpica/files/fix-parallel-build.patch b/meta-oe/recipes-extended/acpica/files/fix-parallel-build.patch
deleted file mode 100644
index 42e3fb1..0000000
--- a/meta-oe/recipes-extended/acpica/files/fix-parallel-build.patch
+++ /dev/null
@@ -1,80 +0,0 @@
-diff --git a/generate/unix/iasl/Makefile b/generate/unix/iasl/Makefile
-index e9520ed..1b73d7a 100644
---- a/generate/unix/iasl/Makefile
-+++ b/generate/unix/iasl/Makefile
-@@ -212,13 +212,10 @@ INTERMEDIATES = \
- MISC = \
- 	$(OBJDIR)/aslcompilerparse.h\
- 	$(OBJDIR)/aslcompiler.y.h\
--	$(OBJDIR)/aslcompilerparse.output\
- 	$(OBJDIR)/dtparserparse.h\
- 	$(OBJDIR)/dtparser.y.h\
--	$(OBJDIR)/dtparserparse.output\
- 	$(OBJDIR)/prparserparse.h\
--	$(OBJDIR)/prparser.y.h\
--	$(OBJDIR)/prparserparse.output
-+	$(OBJDIR)/prparser.y.h
- 
- #
- # Flags specific to iASL compiler
-@@ -240,21 +237,29 @@ include ../Makefile.rules
- $(OBJDIR)/aslcompilerlex.c :   $(ASL_COMPILER)/aslcompiler.l $(ASL_COMPILER)/aslsupport.l
- 	$(LEX) $(LFLAGS) -PAslCompiler -o$@ $(ASL_COMPILER)/aslcompiler.l
- 
--$(OBJDIR)/aslcompilerparse.c $(OBJDIR)/aslcompilerparse.h : $(ASL_COMPILER)/aslcompiler.y
-+$(OBJDIR)/aslcompilerparse.c : $(ASL_COMPILER)/aslcompiler.y
- 	$(YACC) $(YFLAGS) -pAslCompiler -o$@ $?
- 
- $(OBJDIR)/dtparserlex.c :      $(ASL_COMPILER)/dtparser.l
- 	$(LEX) $(LFLAGS) -PDtParser -o$@ $?
- 
--$(OBJDIR)/dtparserparse.c $(OBJDIR)/dtparserparse.h : $(ASL_COMPILER)/dtparser.y
-+$(OBJDIR)/dtparserparse.c : $(ASL_COMPILER)/dtparser.y
- 	$(YACC) $(YFLAGS) -pDtParser -o$@ $?
- 
- $(OBJDIR)/prparserlex.c :      $(ASL_COMPILER)/prparser.l
- 	$(LEX) $(LFLAGS) -PPrParser -o$@ $?
- 
--$(OBJDIR)/prparserparse.c $(OBJDIR)/prparserparse.h : $(ASL_COMPILER)/prparser.y
-+$(OBJDIR)/prparserparse.c : $(ASL_COMPILER)/prparser.y
- 	$(YACC) $(YFLAGS) -pPrParser -o$@ $?
- 
-+$(OBJDIR)/aslcompilerparse.h : $(OBJDIR)/aslcompilerparse.c
-+	touch $@
-+
-+$(OBJDIR)/dtparserparse.h : $(OBJDIR)/dtparserparse.c
-+	touch $@
-+
-+$(OBJDIR)/prparserparse.h:  $(OBJDIR)/prparserparse.c
-+	touch $@
- 
- #
- # Rename the headers produced by bison/yacc
-@@ -279,19 +284,21 @@ $(OBJDIR)/prparser.y.h: $(OBJDIR)/prparserparse.h
- # by the utilities above and they are not necessarily ANSI C, etc.
- #
- $(OBJDIR)/aslcompilerlex.o :   $(OBJDIR)/aslcompilerlex.c
--	$(CC) -c $(CFLAGS) -Wall -o$@ $?
-+	$(CC) -c $(CFLAGS) -Wall -o$@ $<
- 
- $(OBJDIR)/aslcompilerparse.o : $(OBJDIR)/aslcompilerparse.c
--	$(CC) -c $(CFLAGS) -Wall -o$@ $?
-+	$(CC) -c $(CFLAGS) -Wall -o$@ $<
- 
- $(OBJDIR)/dtparserlex.o :      $(OBJDIR)/dtparserlex.c
--	$(CC) -c $(CFLAGS) -Wall -o$@ $?
-+	$(CC) -c $(CFLAGS) -Wall -o$@ $<
- 
- $(OBJDIR)/dtparserparse.o :    $(OBJDIR)/dtparserparse.c
--	$(CC) -c $(CFLAGS) -Wall -o$@ $?
-+	$(CC) -c $(CFLAGS) -Wall -o$@ $<
- 
- $(OBJDIR)/prparserlex.o :      $(OBJDIR)/prparserlex.c
--	$(CC) -c $(CFLAGS) -Wall -o$@ $?
-+	$(CC) -c $(CFLAGS) -Wall -o$@ $<
- 
- $(OBJDIR)/prparserparse.o :    $(OBJDIR)/prparserparse.c
--	$(CC) -c $(CFLAGS) -Wall -o$@ $?
-+	$(CC) -c $(CFLAGS) -Wall -o$@ $<
-+
-+$(OBJECTS): $(HEADERS)
diff --git a/meta-oe/recipes-extended/acpica/files/no-werror.patch b/meta-oe/recipes-extended/acpica/files/no-werror.patch
index 9f96552..5d28f47 100644
--- a/meta-oe/recipes-extended/acpica/files/no-werror.patch
+++ b/meta-oe/recipes-extended/acpica/files/no-werror.patch
@@ -8,29 +8,25 @@ Author: Fathi Boudra <fathi.boudra@linaro.org>
 
 --- a/generate/unix/iasl/Makefile
 +++ b/generate/unix/iasl/Makefile
-@@ -279,19 +279,19 @@ $(OBJDIR)/prparser.y.h: $(OBJDIR)/prpars
+@@ -266,19 +266,19 @@ $(OBJDIR)/prparser.y.h: $(OBJDIR)/prpars
  # by the utilities above and they are not necessarily ANSI C, etc.
  #
  $(OBJDIR)/aslcompilerlex.o :   $(OBJDIR)/aslcompilerlex.c
--	$(CC) -c $(CFLAGS) -Wall -Werror -o$@ $?
-+	$(CC) -c $(CFLAGS) -Wall -o$@ $?
+-	$(CC) -c $(CFLAGS) -Wall -Werror -o$@ $<
++	$(CC) -c $(CFLAGS) -Wall -o$@ $<
  
  $(OBJDIR)/aslcompilerparse.o : $(OBJDIR)/aslcompilerparse.c
--	$(CC) -c $(CFLAGS) -Wall -Werror -o$@ $?
-+	$(CC) -c $(CFLAGS) -Wall -o$@ $?
+-	$(CC) -c $(CFLAGS) -Wall -Werror -o$@ $<
++	$(CC) -c $(CFLAGS) -Wall -o$@ $<
  
  $(OBJDIR)/dtparserlex.o :      $(OBJDIR)/dtparserlex.c
--	$(CC) -c $(CFLAGS) -Wall -Werror -o$@ $?
-+	$(CC) -c $(CFLAGS) -Wall -o$@ $?
+-	$(CC) -c $(CFLAGS) -Wall -Werror -o$@ $<
++	$(CC) -c $(CFLAGS) -Wall -o$@ $<
  
  $(OBJDIR)/dtparserparse.o :    $(OBJDIR)/dtparserparse.c
--	$(CC) -c $(CFLAGS) -Wall -Werror -o$@ $?
-+	$(CC) -c $(CFLAGS) -Wall -o$@ $?
+-	$(CC) -c $(CFLAGS) -Wall -Werror -o$@ $<
++	$(CC) -c $(CFLAGS) -Wall -o$@ $<
  
  $(OBJDIR)/prparserlex.o :      $(OBJDIR)/prparserlex.c
--	$(CC) -c $(CFLAGS) -Wall -Werror -o$@ $?
-+	$(CC) -c $(CFLAGS) -Wall -o$@ $?
- 
- $(OBJDIR)/prparserparse.o :    $(OBJDIR)/prparserparse.c
--	$(CC) -c $(CFLAGS) -Wall -Werror -o$@ $?
-+	$(CC) -c $(CFLAGS) -Wall -o$@ $?
+-	$(CC) -c $(CFLAGS) -Wall -Werror -o$@ $<
++	$(CC) -c $(CFLAGS) -Wall -o$@ $<